= nng_http_req_set_header(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_req_set_header - set HTTP request header

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_req_set_header(nng_http_req *req, const char *key,
    const char *val);
----

== DESCRIPTION

The `nng_http_req_set_header()` sets the HTTP header for the request
_req_ and the _key_ to the _val_.
The _key_ and _val_ are copied.
Any previous header with the same _key_ is replaced.

TIP: See xref:nng_http_req_add_header.3http.adoc[`nng_http_req_add_header()`] to
add additional headers with the same _key_ without replacing them.

The value of _key_ is case insensitive, and should not include the final
colon in an HTTP header.
For example, specifying `Host` or `hOSt` are
equivalent, whereas the value `Host:` is not a legal header key.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient memory to perform the operation.
`NNG_ENOTSUP`:: No support for HTTP in the library.

== SEE ALSO

[.text-left]
xref:nng_http_req_alloc.3http.adoc[nng_http_req_alloc(3http)],
xref:nng_http_req_add_header.3http.adoc[nng_http_req_add_header(3http)],
xref:nng_http_req_del_header.3http.adoc[nng_http_req_del_header(3http)],
xref:nng_http_req_get_header.3http.adoc[nng_http_req_get_header(3http)],
xref:nng.7.adoc[nng(7)]
